#/bin/bash

echo > /etc/resolv.conf

OUTPUT=/home/robotino/.packages/pkginfo_output
EA09CMD="/usr/local/OpenRobotinoAPI/1/bin/linux/ea09cmd"
ARMCMD="/usr/local/OpenRobotinoAPI/1/bin/linux/arm_cmd"

rm -f "$OUTPUT"

FILES="$@"
for f in $FILES
do
	if [ "robotino-firmware" == "$f" ] ; then
		echo "Package: robotino-firmware" >> $OUTPUT
		if [ -a "$EA09CMD" ] ; then
			ret=`$EA09CMD getinfo`
			if [ 0 -eq $? ] ; then 
				echo Version: "$ret" >> $OUTPUT
				echo Status: ii >> $OUTPUT
			fi
		fi
	elif [ "robotinoarm-firmware" == "$f" ] ; then
		echo "Package: robotinoarm-firmware" >> $OUTPUT
		if [ -a "$ARMCMD" ] ; then
			ret=`$ARMCMD getinfo`
			if [ 0 -eq $? ] ; then 
				echo Version: "$ret" >> $OUTPUT
				echo Status: ii >> $OUTPUT
			fi
		fi
	else
		ret=`apt-cache show "$f" 2>/dev/null`
		if [ -z "$ret" ] ; then
			echo Package: "$f" >> $OUTPUT
		else
			echo "$ret" >> $OUTPUT
			status=`dpkg -l "$f" 2>1 | grep "^..  " | sed -n 's/ \+.*//;p'`
			if [ -n $status ] ; then
				echo Status: $status >> $OUTPUT
			fi
		fi
	fi

	echo "" >> $OUTPUT
done

echo "pkginfo finished"
