#!/bin/bash

# returns 0 if Allnet AP with factory settings is found
# returns 1 if Allnet AP with Festo settings in Client mode is found
# returns 2 if Allnet AP with Festo settings in AP mode is found
# returns 3 if no Allnet AP is found

LOGFILE=/var/log/lcdd_scripts

ALLNET_IP1=192.168.1.1
ALLNET_PW1=admin
ALLNET_IP2=172.26.101.1
ALLNET_PW2=apap6

WGETPARAM="--auth-no-challenge  --timeout=8 --tries=2 --http-user=admin  --wait=2 -q"   #-q  #-d
WGETPARAM1="$WGETPARAM --http-passwd=$ALLNET_PW1"
WGETPARAM2="$WGETPARAM --http-passwd=$ALLNET_PW2"

myecho()
{
	echo "$1"
	echo "$1" >> $LOGFILE
}

myecho "Searching for Allnet-AccessPoint"
wget http://$ALLNET_IP2/status.asp $WGETPARAM2 -O /tmp/.wget
if [ 0 -eq $? ] ; then
	myecho "Allnet with Festo settings found"
	grep "wlanMode\[0] =0;" /tmp/.wget
	if [ 0 -eq $? ] ; then
		myecho "Allnet in AP mode"
		exit 2
	fi
	myecho "Allnet in Client mode"
	exit 1
fi

ifconfig eth0:10 192.168.1.250 netmask 255.255.255.0 up
myecho "Searching 2x8 seconds for Allnet-AccessPoint with factory settings."
wget http://${ALLNET_IP1}/status.asp $WGETPARAM1 -O- > /dev/null
RET=$?
ifconfig eth0:10 down
if [ 0 -eq $RET ] ; then
	myecho "Allnet with factory settings found"
	exit 0
fi



myecho "No Allnet AP found"
exit 3
