#!/bin/bash

# call script  ./allnet_ap_init.sh 5.123  to programm  SSID Robotino.5.123
# to show wget outputs delete parameter  -q    or add parameter -d for even more debug-infos

LOGFILE=/var/log/lcdd_scripts

AP_SSID=Robotino.$1


ALLNET_IP1=192.168.1.1
ALLNET_PW1=admin
ALLNET_IP2=172.26.101.1
ALLNET_PW2=apap6

WGETPARAM="--auth-no-challenge  --timeout=8 --tries=2 --http-user=admin  --wait=2 -q"   #-q  #-d
WGETPARAM1="$WGETPARAM --http-passwd=$ALLNET_PW1"
WGETPARAM2="$WGETPARAM --http-passwd=$ALLNET_PW2"

ifconfig eth0:10 192.168.1.250 netmask 255.255.255.0 up

myecho()
{
	echo "$1"
	echo "$1" >> $LOGFILE
}

error_exit()
{
	myecho "Error: $1"
	ifconfig eth0:10 down
	exit 1
}

myecho "Searching 2x8 seconds for Allnet-AccessPoint."
wget http://${ALLNET_IP1}/status.asp $WGETPARAM1   -O /tmp/.wget || error_exit "No Allnet found"

grep "^ssid_drv\[0\] ='WLAN-11g-AP';" /tmp/.wget || error_exit "No Allnet AP with factory settings found"

myecho "Allnet AP with factory settings found"
myecho

grep "wlanMode\[0] =0;" /tmp/.wget || error_exit "Not in AP mode"

myecho "Setup SSID $AP_SSID in AP-mode..."
wget http://$ALLNET_IP1/goform/formWlanSetup     --post-data="ssid0=$AP_SSID&reg0=1&chan0=0&wlan-url=%2Fwlbasic.asp&save=Apply+Changes&basicrates0=15&operrates0=4095"  $WGETPARAM1 -O-  || error_exit "Setup new SSID in AP mode"

myecho "Setup new password"
wget http://$ALLNET_IP1/goform/formPasswordSetup --post-data="username=admin&newpass=$ALLNET_PW2&confpass=$ALLNET_PW2&submit-url=%2Fstatus.asp&save=Apply+Changes"      $WGETPARAM1 -O-  || error_exit "Setup new password"

myecho "Setup LAN inteface and DHCP=ON ..."
wget http://$ALLNET_IP1/goform/formTcpipSetup    --post-data="lan_ip=$ALLNET_IP2&lan_mask=255.255.0.0&lan_gateway=$ALLNET_IP2&dhcp=2&dhcpRangeStart=172.26.201.1&dhcpRangeEnd=172.26.201.100&dns1=0.0.0.0&domainName=&stp=0&lan_macAddr=000000000000&save=Apply+Changes&submit-url=%2Ftcpip.asp"  $WGETPARAM2  -O- || error_exit "Setup LAN interface and DHCP=ON"

ifconfig eth0:10 down

myecho "wait 20 sec for AP-restart..."

for i in {1..20}
do
	myecho "."
	sleep 1
done

myecho "Check if new SSID has been written"
wget http://$ALLNET_IP2/status.asp $WGETPARAM2 -O- | grep "^ssid_drv\[0\] ='$AP_SSID';" || error_exit "Failed writing new SSID"
myecho "Success"

exit 0

