#!/bin/bash

VERSIONFILE=`ls /version_*`

YEAR=${VERSIONFILE:9:4}
MONTH=${VERSIONFILE:13:2}
DAY=${VERSIONFILE:15:2}
VERSION=$(( YEAR*10000 + MONTH*100 + DAY ))

V20VERSION=20091130
V22VERSION=20101201
V24VERSION=20110221

if (( VERSION <= V20VERSION )) ; then
  echo v2.0
  exit 0
fi

if (( VERSION < V22VERSION )) ; then
	echo v2.1
	exit 0
fi

if (( VERSION == V22VERSION )) ; then
  echo v2.2
  exit 0
fi

if (( VERSION == V24VERSION )) ; then
  echo v2.4
  exit 0
fi

if (( VERSION > V24VERSION )) ; then
  echo v2.5
  exit 0
fi

echo v2.x
