#!/usr/bin/perl

# return values:
# 0: OK
# 1: Wrong number of parameters
# 2: Template does not exist or /etc/network/interfaces not availables for writing
# 3: IP-Address not in correct format
# 4: Netmask not in correct format
# 5: failure reconfiguring address

if( $#ARGV != 1 )
{
  exit( 1 );
}

my ($ip, $netmask) = @ARGV;

if( $ip !~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/ )
{
  exit( 3 );
}

if( $netmask !~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/ )
{
  exit( 4 );
}

my $cfgtpl = "/etc/network/interfaces.tpl";
my $cfg = "/etc/network/interfaces";

open( IFTPL, "<$cfgtpl" ) or exit( 2 );
open( IFBACKUP, "<$cfg" ) or exit( 2 );

my $save = '';
while( <IFBACKUP> )
{
  $save .= $_;
}

open( IF, ">$cfg" ) or exit( 2 );

my $line;
while( $line = <IFTPL> )
{
  if( $line =~ /\%ADDRESS\%/ )
  {
    $line =~ s/\%ADDRESS\%/$ip/;
  }
  if( $line =~ /\%NETMASK\%/ )
  {
    $line =~ s/\%NETMASK\%/$netmask/;
  }
  print IF $line;
}

close( IF );
close( IFTPL );

my $ret = system( "ifdown -a && ifup -a" );
if( $ret != 0 )
{
	open( IF, ">$cfg" ) or exit( 2 );
	print IF $save;
	close( IF );
	system( "sync" );
  exit( 5 );
}
else
{
	system( "sync" );
  exit( 0 );
}
