#!/bin/sh

SERVICEPATH=/usr/local/OpenRobotinoAPI/1/daemons
SERVICE=srd
PARAM=-daemon

startservice()
{
  start-stop-daemon --background --start --quiet --chdir $SERVICEPATH --exec $SERVICEPATH/$SERVICE -- $PARAM
  if [ $? -eq 0 ] ; then
    echo $SERVICE started
  fi
}

stopservice()
{
 start-stop-daemon --stop --retry 10 --signal INT --name $SERVICE
 if [ $? -eq 0 ] ; then
  echo $SERVICE stopped
 fi
}

case "$1" in
    start)
	. $SERVICEPATH/configure_alsa.sh
	startservice 
        ;;

    stop)
        stopservice 
        ;;

    restart)
        stopservice 
        startservice 
        ;;
    *)
        echo "Usage: $0 {start|stop|restart}"
        exit 1
        ;;
esac

