//  Copyright (C) 2004-2009, Robotics Equipment Corporation GmbH

#ifndef _CAMERAVIEW_H_
#define _CAMERAVIEW_H_

#include <QtGui>
#include "MarkerTracker.h"

#include "rec/robotino/com/Camera.h"
#include "rec/robotino/com/OmniDrive.h"

class CameraView : public QWidget, public rec::robotino::com::Camera
{
	Q_OBJECT
public:
	CameraView();

private:
	void paintEvent( QPaintEvent* e );

	/**
	This function overwrites rec::robotino::com::Camera::imageReceivedEvent
	*/
	void imageReceivedEvent( const unsigned char* data,
		                       unsigned int dataSize,
													 unsigned int width,
													 unsigned int height,
													 unsigned int numChannels,
													 unsigned int bytesPerChannel,
													 unsigned int step );

	QImage _image;
	MarkerTracker _tracker;
	rec::robotino::com::OmniDrive _omniDrive;
};

#endif
