#ifndef _MYCOM_H_
#define _MYCOM_H_

#include <QtGui>
#include "rec/robotino/com/Com.h"

class MyCom : public QObject, public rec::robotino::com::Com
{
	Q_OBJECT
public:
	MyCom( QObject* parent );

public Q_SLOTS:
	void connectToHost( const QString& address );

	void disconnectFromHost();

Q_SIGNALS:
	void connectionStateChanged( bool isConnected );

private:
	/**
	This function overwrites rec::robotino::com::Com::connectionStateChangedEvent
	*/
	void connectionStateChangedEvent( rec::robotino::com::Com::ConnectionState newState, rec::robotino::com::Com::ConnectionState oldState );

	QTimer* _timer;

private Q_SLOTS:
	void on_timer_timeout();
};

#endif //_MYCOM_H_
