//  Copyright (C) 2004-2008, Robotics Equipment Corporation GmbH

#define _USE_MATH_DEFINES
#include <cmath>
#include <iostream>

#include "rec/sharedmemory/sharedmemory.h"
#include "rec/iocontrol/robotstate/State.h"
#include "rec/iocontrol/robotstate/Decoder.h"
#include "rec/iocontrol/robotstate/Encoder.h"
#include "rec/core_lt/utils.h"

using rec::iocontrol::robotstate::Encoder;
using rec::iocontrol::robotstate::Decoder;
using rec::iocontrol::robotstate::State;
using rec::sharedmemory::SharedMemory;
using rec::sharedmemory::Lock;

SharedMemory< State >* mem = NULL;

int main( int argc, char **argv )
{
	mem = new SharedMemory< State >( State::sharedMemoryKey );
	State* state = mem->getData();

	while( 1 )
	{
		{
			Lock lk( mem );
			double x, y, phi;
			state->getOdometry( &x, &y, &phi );
			std::cout << x << "  " << y << "  " << phi << std::endl;
		}
		rec::core_lt::msleep( 500 );
	}
}
