//  Copyright (C) 2004-2009, Robotics Equipment Corporation GmbH

#include "AddressInput.h"

AddressInput::AddressInput()
: _lineEdit( new QLineEdit )
, _connectButton( new QPushButton )
, _isConnected( false )
{
	QHBoxLayout* layout = new QHBoxLayout;
	setLayout( layout );

	_connectButton->setText( "Connect" );
	_lineEdit->setText( "172.26.1.1" );

	layout->addWidget( _lineEdit );
	layout->addWidget( _connectButton );

	connect(
		_connectButton,
		SIGNAL( clicked() ),
		SLOT( on_connectButton_clicked() )
		);
}

void AddressInput::on_connectButton_clicked()
{
	if( _isConnected )
	{
		Q_EMIT disconnectFromHost();
	}
	else
	{
		Q_EMIT connectToHost( _lineEdit->text() );
	}
}

void AddressInput::connectionStateChanged( bool isConnected )
{
	_isConnected = isConnected;

	if( _isConnected )
	{
		_connectButton->setEnabled( true );
		_connectButton->setText( "Disconnect" );
		_lineEdit->setEnabled( false );
	}
	else
	{
		_connectButton->setText( "Connect" );
		_connectButton->setEnabled( true );
		_lineEdit->setEnabled( true );
	}
}
