//  Copyright (C) 2004-2009, Robotics Equipment Corporation GmbH

#include "CameraView.h"

#include "rec/core_lt/image/conv.h"

#include <iostream>

CameraView::CameraView()
{
	rec::robotino::com::Camera::setStreaming( true );
	std::cout << "CameraView initialized!" << std::endl;
	setMinimumSize( 320, 240 );
}

void CameraView::paintEvent( QPaintEvent* e )
{
	QPainter painter( this );

	painter.drawImage( rect(), _image );
}

void CameraView::imageReceivedEvent( const unsigned char* data,
									unsigned int dataSize,
									unsigned int width,
									unsigned int height,
									unsigned int numChannels,
									unsigned int bytesPerChannel,
									unsigned int step )
{
	std::cout << "Received an image:Data:" << (int)data << " " << width << " " << height << std::endl;
	QImage newImage( data, width, height, QImage::Format_RGB888 );
	_image = newImage.copy();
	update();
}

