//  Copyright (C) 2004-2009, Robotics Equipment Corporation GmbH

#include "MainWindow.h"

#include "CameraView.h"
#include "ControlPanel.h"
#include "AddressInput.h"

MainWindow::MainWindow()
: _myCom( new MyCom( this ) )
{
	AddressInput* addressInput = new AddressInput;
	ControlPanel* controlPanel = new ControlPanel;

	QDockWidget* addressInputDock = new QDockWidget( "Adress input", this );
	addressInputDock->setWidget( addressInput );
	addressInputDock->setFeatures( QDockWidget::DockWidgetMovable | QDockWidget::DockWidgetFloatable );
	addDockWidget(Qt::TopDockWidgetArea, addressInputDock );
	addressInputDock->setFloating( false );
	addressInputDock->setVisible( true );

	QDockWidget* controlPanelDock = new QDockWidget( "Control panel", this );
	controlPanelDock->setWidget( controlPanel );
	controlPanelDock->setFeatures( QDockWidget::DockWidgetMovable | QDockWidget::DockWidgetFloatable );
	addDockWidget(Qt::BottomDockWidgetArea, controlPanelDock );
	controlPanelDock->setFloating( false );
	controlPanelDock->setVisible( true );

	connect( addressInput, SIGNAL( connectToHost( const QString& ) ),
			_myCom, SLOT( connectToHost( const QString& ) ) );

	connect( addressInput, SIGNAL( disconnectFromHost() ),
			_myCom, SLOT( disconnectFromHost() ) );

	connect( _myCom, SIGNAL( connectionStateChanged( bool ) ),
			addressInput, SLOT( connectionStateChanged( bool ) ) );

	setCentralWidget( new CameraView );
}
