#include "MyCom.h"
#include <QtDebug>

MyCom::MyCom( QObject* parent )
: QObject( parent )
, rec::robotino::com::Com( true ) //events will be emitted when calling rec::robotino::com::Com::processEvents
, _timer( new QTimer( this ) )
{
	setMinimumUpdateCycleTime( 0 );
	QObject::connect( _timer, SIGNAL( timeout() ), SLOT( on_timer_timeout() ) );

	//Q_EMIT the timeout signal every time the event loop is processed
	_timer->setInterval( 0 );
	_timer->setSingleShot( false );
	_timer->start();
}

void MyCom::connectToHost( const QString& address )
{
	if( isConnected() )
	{
		qDebug() << "Already connected to " << rec::robotino::com::Com::address();
		return;
	}

	rec::robotino::com::Com::setAddress( address.toLatin1().constData() );

	rec::robotino::com::Com::connect( false );
}

void MyCom::disconnectFromHost()
{
	rec::robotino::com::Com::disconnect();
}

void MyCom::on_timer_timeout()
{
	rec::robotino::com::Com::processEvents();
}

void MyCom::connectionStateChangedEvent( rec::robotino::com::Com::ConnectionState newState, rec::robotino::com::Com::ConnectionState oldState )
{
	if( rec::robotino::com::Com::Connected == newState )
	{
		Q_EMIT connectionStateChanged( true );
	}
	else if( rec::robotino::com::Com::NotConnected == newState )
	{
		Q_EMIT connectionStateChanged( false );
	}
}
