//  Copyright (C) 2004-2011, Robotics Equipment Corporation GmbH

#ifndef _REC_ROBOTINO_COM_COMPACTBHASIMPLE_H_
#define _REC_ROBOTINO_COM_COMPACTBHASIMPLE_H_

namespace rec
{
	namespace robotino
	{
		namespace com
		{
			/**
			* @brief	Calculation from xy coordinates to pressures
			*
			* See <a href="http://wiki.openrobotino.org/index.php?title=CBHA">here</a> for further details.
			*/
			class
#ifdef WIN32
#  ifdef rec_robotino_com_EXPORTS
		__declspec(dllexport)
#  endif
#  ifdef rec_robotino_com2_EXPORTS
		__declspec(dllexport)
#  endif
#  ifdef rec_robotino_com3_EXPORTS
		__declspec(dllexport)
#  endif
#else
#  ifndef SWIG
    __attribute__ ((visibility ("default")))
#  endif
#endif
			CompactBHASimple
			{
			public:
				/**
				* @param x x-coordinate
				* @param y y-coordinate
				* @param top Normalized pressure for top bellow
				* @param bottomleft Normalized pressure for bottom left bellow
				* @param bottomright Normalized pressure for bottom right bellow
				*/
				static void xy2pressure( float x, float y, float* b1, float* b2, float* b3 );

			private:
				CompactBHASimple();
			};
		}
	}
}

#endif //_REC_ROBOTINO_COM_COMPACTBHASIMPLE_H_
