//  Copyright (C) 2004-2010, Robotics Equipment Corporation GmbH

#ifndef _REC_ROBOTINO_COM_LASERRANGEFINDERREADINGS_H_
#define _REC_ROBOTINO_COM_LASERRANGEFINDERREADINGS_H_

#include <vector>
#include <string>

namespace rec
{
	namespace robotino
	{
		namespace com
		{
			/**
			* @brief	Sensor readings of Robotino's (optional) laser rangefinder
			*/
			class
#ifdef WIN32
#  ifdef rec_robotino_com_EXPORTS
		__declspec(dllexport)
#  endif
#  ifdef rec_robotino_com2_EXPORTS
		__declspec(dllexport)
#  endif
#  ifdef rec_robotino_com3_EXPORTS
		__declspec(dllexport)
#  endif
#else
#  ifndef SWIG
    __attribute__ ((visibility ("default")))
#  endif
#endif
			LaserRangeFinderReadings
			{
			public:
				LaserRangeFinderReadings()
					: seq( 0 )
					, stamp( 0 )
					, angle_min( 0.0f )
					, angle_max( 0.0f )
					, angle_increment( 0.0f )
					, time_increment( 0.0f )
					, range_min( 0.0f )
					, range_max( 0.0f )
				{
				}

				unsigned int seq;
				unsigned int stamp;
				std::string frame_id;

				float angle_min;
				float angle_max;
				float angle_increment;
				float time_increment;
				float scan_time;
				float range_min;
				float range_max;

				std::vector< float > ranges;
				std::vector< float > intensities;
			};
		}
	}
}

#endif //_REC_ROBOTINO_COM_LASERRANGEFINDERREADINGS_H_
