//  Copyright (C) 2004-2010, Robotics Equipment Corporation GmbH

#ifndef _REC_ROBOTINO_COM_MANIPULATORLIMITS_H_
#define _REC_ROBOTINO_COM_MANIPULATORLIMITS_H_

#include <vector>

namespace rec
{
	namespace robotino
	{
		namespace com
		{
			/**
			* @brief	Sensor readings of Robotino's (optional) manipulator
			*/
			class
#ifdef WIN32
#  ifdef rec_robotino_com_EXPORTS
		__declspec(dllexport)
#  endif
#  ifdef rec_robotino_com2_EXPORTS
		__declspec(dllexport)
#  endif
#  ifdef rec_robotino_com3_EXPORTS
		__declspec(dllexport)
#  endif
#else
#  ifndef SWIG
    __attribute__ ((visibility ("default")))
#  endif
#endif
			ManipulatorLimits
			{
			public:
				ManipulatorLimits()
					: seq( 0 )
				{
				}

				/**
				The CW limit of the axes in deg.
				*/
				std::vector<float> cwAxesLimits;

				/**
				The CCW limit of the axes in deg.
				*/
				std::vector<float> ccwAxesLimits;
			
				unsigned int seq;
			};
		}
	}
}

#endif //_REC_ROBOTINO_COM_MANIPULATORLIMITS_H_
