//  Copyright (C) 2004-2010, Robotics Equipment Corporation GmbH

#ifndef _REC_ROBOTINO_COM_MANIPULATORLIMITSSSHARED_H_
#define _REC_ROBOTINO_COM_MANIPULATORLIMITSSSHARED_H_

#ifdef HAVE_QT

#include "rec/robotino/com/ManipulatorLimits.h"

#include <QSharedData>
#include <QMetaType>

namespace rec
{
	namespace robotino
	{
		namespace com
		{

			class ManipulatorLimitsSharedData : public QSharedData
			{
			public:
				ManipulatorLimitsSharedData()
				{
				}

				ManipulatorLimitsSharedData( const ManipulatorLimitsSharedData& other )
					: QSharedData( other )
					, limits( other.limits )
				{
				}

				rec::robotino::com::ManipulatorLimits limits;
			};

			class ManipulatorLimitsShared
			{
			public:
				ManipulatorLimitsShared()
					: d( new ManipulatorLimitsSharedData )
				{
				}

				ManipulatorLimitsShared( const rec::robotino::com::ManipulatorLimits& r )
					: d( new ManipulatorLimitsSharedData )
				{
					d->limits = r;
				}

				rec::robotino::com::ManipulatorLimits& limits()
				{
					return d->limits;
				}

				const rec::robotino::com::ManipulatorLimits& limits() const
				{
					return d->limits;
				}

			private:
				QSharedDataPointer<ManipulatorLimitsSharedData> d;
			};
		}
	}
}

Q_DECLARE_METATYPE(rec::robotino::com::ManipulatorLimits)
Q_DECLARE_METATYPE(rec::robotino::com::ManipulatorLimitsShared)

#endif //HAVE_QT
#endif //_REC_ROBOTINO_COM_MANIPULATORLIMITSSSHARED_H_
