//  Copyright (C) 2004-2010, Robotics Equipment Corporation GmbH

#ifndef _REC_ROBOTINO_COM_MANIPULATORREADINGSSHARED_H_
#define _REC_ROBOTINO_COM_MANIPULATORREADINGSSHARED_H_

#ifdef HAVE_QT

#include "rec/robotino/com/ManipulatorReadings.h"

#include <QSharedData>
#include <QMetaType>

namespace rec
{
	namespace robotino
	{
		namespace com
		{

			class ManipulatorReadingsSharedData : public QSharedData
			{
			public:
				ManipulatorReadingsSharedData()
				{
				}

				ManipulatorReadingsSharedData( const ManipulatorReadingsSharedData& other )
					: QSharedData( other )
					, readings( other.readings )
				{
				}

				rec::robotino::com::ManipulatorReadings readings;
			};

			class ManipulatorReadingsShared
			{
			public:
				ManipulatorReadingsShared()
					: d( new ManipulatorReadingsSharedData )
				{
				}

				ManipulatorReadingsShared( const rec::robotino::com::ManipulatorReadings& r )
					: d( new ManipulatorReadingsSharedData )
				{
					d->readings = r;
				}

				rec::robotino::com::ManipulatorReadings& readings()
				{
					return d->readings;
				}

				const rec::robotino::com::ManipulatorReadings& readings() const
				{
					return d->readings;
				}

			private:
				QSharedDataPointer<ManipulatorReadingsSharedData> d;
			};
		}
	}
}

Q_DECLARE_METATYPE(rec::robotino::com::ManipulatorReadings)
Q_DECLARE_METATYPE(rec::robotino::com::ManipulatorReadingsShared)

#endif //HAVE_QT
#endif //_REC_ROBOTINO_COM_MANIPULATORREADINGSSHARED_H_
