INCLUDE (architecture)
DETERMINE_ARCHITECTURE()

STRING( REPLACE "\\" "/" OPENROBOTINOAPI_DIR "$ENV{OPENROBOTINOAPI_DIR}" )

IF( NOT OPENROBOTINOAPI_DIR )
	IF( WIN64 )
		STRING( REPLACE "\\" "/" PROGRAMS "$ENV{ProgramFiles(x86)}" )
		SET( OPENROBOTINOAPI_DIR "${PROGRAMS}/REC GmbH/OpenRobotinoAPI" )
	ELSEIF( WIN32 )
		STRING( REPLACE "\\" "/" PROGRAMS "$ENV{ProgramFiles}" )
		SET( OPENROBOTINOAPI_DIR "${PROGRAMS}/REC GmbH/OpenRobotinoAPI" )
	ELSE( WIN64 )
		SET( OPENROBOTINOAPI_DIR "/usr/local/OpenRobotinoAPI" )
	ENDIF( WIN64 )
ENDIF( NOT OPENROBOTINOAPI_DIR )

IF( EXISTS "${OPENROBOTINOAPI_DIR}/1" )
	MARK_AS_ADVANCED( OPENROBOTINOAPI_DIR )
	SET( OPENROBOTINO1_DIR "${OPENROBOTINOAPI_DIR}/1" )
	SET( OPENROBOTINO1_INCLUDE_PATH "${OPENROBOTINO1_DIR}/include" )
	SET( OPENROBOTINO1_LIB_DIR "${OPENROBOTINO1_DIR}/lib/${ARCH}" )
	SET( OPENROBOTINO1_BIN_DIR "${OPENROBOTINO1_DIR}/bin/${ARCH}" )
	
	SET( OPENROBOTINO_SHARE_DIR "${OPENROBOTINOAPI_DIR}/share" )
	SET( OPENROBOTINO_SHARE_INCLUDE_PATH "${OPENROBOTINO_SHARE_DIR}/include" )
	SET( OPENROBOTINO_SHARE_LIB_DIR "${OPENROBOTINO_SHARE_DIR}/lib/${ARCH}" )
	SET( OPENROBOTINO_SHARE_BIN_DIR "${OPENROBOTINO_SHARE_DIR}/bin/${ARCH}" )
	
	SET( OPENROBOTINO_EXTERNAL_DIR "${OPENROBOTINOAPI_DIR}/external" )
	SET( OPENROBOTINO_EXTERNAL_INCLUDE_PATH "${OPENROBOTINO_EXTERNAL_DIR}/include" )
	
ENDIF( EXISTS "${OPENROBOTINOAPI_DIR}/1" )
	
FIND_PATH(
   OPENROBOTINO1_INCLUDE_DIR 
   NAMES
   rec/robotino/com/Com.h
   PATHS
   ${OPENROBOTINO1_INCLUDE_PATH}
   NO_DEFAULT_PATH
)

FIND_PATH(
   OPENROBOTINO_SHARE_INCLUDE_DIR 
   NAMES
   rec/core_lt/Timer.h
   PATHS
   ${OPENROBOTINO_SHARE_INCLUDE_PATH}
   NO_DEFAULT_PATH
)

FIND_LIBRARY(
  REC_ROBOTINO_COM_RELEASE_LIBRARY
  NAMES rec_robotino_com
  PATHS "${OPENROBOTINO1_LIB_DIR}"
)

FIND_LIBRARY(
  REC_ROBOTINO_SERVER_RELEASE_LIBRARY
  NAMES rec_robotino_server
  PATHS "${OPENROBOTINO1_LIB_DIR}"
)

FIND_LIBRARY(
  REC_ROBOTINO_IMAGESENDER_RELEASE_LIBRARY
  NAMES rec_robotino_imagesender
  PATHS "${OPENROBOTINO1_LIB_DIR}"
)

FIND_LIBRARY(
  REC_CORE_LT_RELEASE_LIBRARY
  NAMES rec_core_lt
  PATHS "${OPENROBOTINO1_LIB_DIR}"
)

FIND_LIBRARY(
  REC_SERIALPORT_RELEASE_LIBRARY
  NAMES rec_serialport
  PATHS "${OPENROBOTINO1_LIB_DIR}"
)

FIND_LIBRARY(
  REC_DATAEXCHANGE_LT_RELEASE_LIBRARY
  NAMES rec_dataexchange_lt
  PATHS "${OPENROBOTINO1_LIB_DIR}"
)

IF( WIN32 )
	FIND_LIBRARY(
		REC_ROBOTINO_COM_DEBUG_LIBRARY
		NAMES rec_robotino_comd
		PATHS "${OPENROBOTINO1_LIB_DIR}"
	)
	
	FIND_LIBRARY(
		REC_ROBOTINO_SERVER_DEBUG_LIBRARY
		NAMES rec_robotino_serverd
		PATHS "${OPENROBOTINO1_LIB_DIR}"
	)
	
	FIND_LIBRARY(
		REC_ROBOTINO_IMAGESENDER_DEBUG_LIBRARY
		NAMES rec_robotino_imagesenderd
		PATHS "${OPENROBOTINO1_LIB_DIR}"
	)
	
	FIND_LIBRARY(
		REC_ROBOTINO_CORE_LT_DEBUG_LIBRARY
		NAMES rec_core_ltd
		PATHS "${OPENROBOTINO1_LIB_DIR}"
	)
	
	FIND_LIBRARY(
		REC_SERIALPORT_DEBUG_LIBRARY
		NAMES rec_dataexchange_ltd
		PATHS "${OPENROBOTINO1_LIB_DIR}"
	)
	
	FIND_LIBRARY(
		REC_DATAEXCHANGE_LT_DEBUG_LIBRARY
		NAMES rec_serialportd
		PATHS "${OPENROBOTINO1_LIB_DIR}"
	)
	
	FIND_FILE( REC_ROBOTINO_COM_DLL rec_robotino_com.dll PATHS "${OPENROBOTINO1_BIN_DIR}" NO_DEFAULT_PATH )
	FIND_FILE( REC_ROBOTINO_COMD_DLL rec_robotino_comd.dll PATHS "${OPENROBOTINO1_BIN_DIR}" NO_DEFAULT_PATH )
	
	FIND_FILE( REC_ROBOTINO_COM_C_DLL rec_robotino_com_c.dll PATHS "${OPENROBOTINO1_BIN_DIR}" NO_DEFAULT_PATH )
	FIND_FILE( REC_ROBOTINO_COM_CD_DLL rec_robotino_com_cd.dll PATHS "${OPENROBOTINO1_BIN_DIR}" NO_DEFAULT_PATH )
	
	FIND_FILE( REC_ROBOTINO_COM_C_NODEP_DLL rec_robotino_com_c_nodep.dll PATHS "${OPENROBOTINO1_BIN_DIR}" NO_DEFAULT_PATH )
	FIND_FILE( REC_ROBOTINO_COM_C_NODEPD_DLL rec_robotino_com_c_nodepd.dll PATHS "${OPENROBOTINO1_BIN_DIR}" NO_DEFAULT_PATH )
  
	FIND_FILE( REC_ROBOTINO_SERVER_DLL rec_robotino_server.dll PATHS "${OPENROBOTINO1_BIN_DIR}" NO_DEFAULT_PATH )
	FIND_FILE( REC_ROBOTINO_SERVERD_DLL rec_robotino_serverd.dll PATHS "${OPENROBOTINO1_BIN_DIR}" NO_DEFAULT_PATH )
  
	FIND_FILE( REC_ROBOTINO_IMAGESENDER_DLL rec_robotino_imagesender.dll PATHS "${OPENROBOTINO1_BIN_DIR}" NO_DEFAULT_PATH )
	FIND_FILE( REC_ROBOTINO_IMAGESENDERD_DLL rec_robotino_imagesenderd.dll PATHS "${OPENROBOTINO1_BIN_DIR}" NO_DEFAULT_PATH )
  
	FIND_FILE( REC_CORE_LT_DLL rec_core_lt.dll PATHS "${OPENROBOTINO1_BIN_DIR}" NO_DEFAULT_PATH )
	FIND_FILE( REC_CORE_LTD_DLL rec_core_ltd.dll PATHS "${OPENROBOTINO1_BIN_DIR}" NO_DEFAULT_PATH )
  
	SET(
		OPENROBOTINO1_RELEASE_DLLS
		${REC_ROBOTINO_COM_DLL}
		${REC_ROBOTINO_SERVER_DLL}
		${REC_ROBOTINO_IMAGESENDER_DLL}
		${REC_CORE_LT_DLL}
	)

	SET(
		OPENROBOTINO1_DEBUG_DLLS
		${REC_ROBOTINO_COMD_DLL}
		${REC_ROBOTINO_SERVERD_DLL}
		${REC_ROBOTINO_IMAGESENDERD_DLL}
		${REC_CORE_LTD_DLL}
	)
ELSE( WIN32 )
	FIND_LIBRARY(
		REC_IOCONTROL_ROBOTSTATE_LIBRARY
		NAMES rec_iocontrol_robotstate
		PATHS "${OPENROBOTINO1_LIB_DIR}"
	)
	FIND_LIBRARY(
		REC_IOCONTROL_SERCOM_LIBRARY
		NAMES rec_iocontrol_sercom
		PATHS "${OPENROBOTINO1_LIB_DIR}"
	)
ENDIF( WIN32 )
	
SET( OPENROBOTINO1_FOUND 0 )

IF( OPENROBOTINO1_INCLUDE_DIR )
	SET( OPENROBOTINO1_FOUND 1 )
ELSE( OPENROBOTINO1_INCLUDE_DIR )
	IF( OPENROBOTINO1_FIND_REQUIRED )
		MESSAGE(FATAL_ERROR "Could not find OPENROBOTINO1. Download from http://forum.openrobotino.org/showthread.php?t=10")
	ENDIF( OPENROBOTINO1_FIND_REQUIRED )
ENDIF( OPENROBOTINO1_INCLUDE_DIR )

IF( OPENROBOTINO1_FOUND )
	INCLUDE_DIRECTORIES(
		${OPENROBOTINO1_INCLUDE_DIR}
		${OPENROBOTINO_SHARE_INCLUDE_DIR}
	)
	
	IF( WIN32 )
		SET( REC_ROBOTINO_COM_LIBRARY optimized ${REC_ROBOTINO_COM_RELEASE_LIBRARY} debug ${REC_ROBOTINO_COM_DEBUG_LIBRARY} )
		SET( REC_ROBOTINO_SERVER_LIBRARY optimized ${REC_ROBOTINO_SERVER_RELEASE_LIBRARY} debug ${REC_ROBOTINO_SERVER_DEBUG_LIBRARY} )
		SET( REC_ROBOTINO_IMAGESENDER_LIBRARY optimized ${REC_ROBOTINO_IMAGESENDER_RELEASE_LIBRARY} debug ${REC_ROBOTINO_IMAGESENDER_DEBUG_LIBRARY} )
		SET( REC_CORE_LT_LIBRARY optimized ${REC_CORE_LT_RELEASE_LIBRARY} debug ${REC_CORE_LT_DEBUG_LIBRARY} )
		SET( REC_SERIALPORT_LIBRARY optimized ${REC_SERIALPORT_RELEASE_LIBRARY} debug ${REC_SERIALPORT_DEBUG_LIBRARY} )
	ELSE( WIN32 )
		SET( REC_ROBOTINO_COM_LIBRARY ${REC_ROBOTINO_COM_RELEASE_LIBRARY} )
		SET( REC_ROBOTINO_SERVER_LIBRARY ${REC_ROBOTINO_SERVER_RELEASE_LIBRARY} )
		SET( REC_ROBOTINO_IMAGESENDER_LIBRARY ${REC_ROBOTINO_IMAGESENDER_RELEASE_LIBRARY} )
		SET( REC_CORE_LT_LIBRARY ${REC_CORE_LT_RELEASE_LIBRARY} )
		SET( REC_SERIALPORT_LIBRARY ${REC_SERIALPORT_RELEASE_LIBRARY} )
		SET( REC_DATAEXCHANGE_LT_LIBRARY ${REC_DATAEXCHANGE_LT_RELEASE_LIBRARY} )
	ENDIF( WIN32 )
	
ENDIF( OPENROBOTINO1_FOUND )

MACRO( COPY_OPENROBOTINO1_DLLS releaseTarget debugTarget releaseWithDebugTarget )
  FOREACH( var ${OPENROBOTINO1_RELEASE_DLLS} )
    CONFIGURE_FILE( ${var} ${releaseTarget} COPYONLY )
  ENDFOREACH( var )
  FOREACH( var ${OPENROBOTINO1_DEBUG_DLLS} )
    CONFIGURE_FILE( ${var} ${debugTarget} COPYONLY )
  ENDFOREACH( var )
  FOREACH( var ${OPENROBOTINO1_RELEASE_DLLS} )
    CONFIGURE_FILE( ${var} ${releaseWithDebugTarget} COPYONLY )
  ENDFOREACH( var )
ENDMACRO( COPY_OPENROBOTINO1_DLLS )

MACRO( USE_OPENROBOTINO1_EXTERNAL )
	INCLUDE_DIRECTORIES(
		${OPENROBOTINO_EXTERNAL_INCLUDE_PATH}
	)
ENDMACRO( USE_OPENROBOTINO1_EXTERNAL )
