MACRO(DETERMINE_ARCHITECTURE)

IF(MINGW)
  SET( ARCH mingw )
  SET( BIN_ARCH mingw )
ELSE(MINGW)
IF( WIN32 )
  
	IF( ${CMAKE_CL_64} )
	  SET( ARCH x64 )
	  SET( BIN_ARCH x64 )
	ELSE( ${CMAKE_CL_64} )
	  SET( ARCH win32 )
	  SET( BIN_ARCH win32 )
	ENDIF( ${CMAKE_CL_64} )
  
	#check for Visual Studio 2003 SP1
  IF( MSVC71 )
		SET( COMPILER_NAME vc71 )
	
	#check for Visual Studio 2005 SP1
	ELSEIF( MSVC80 )
		SET( COMPILER_NAME vc80 )
	
	#check for Visual Studio 2008
	ELSEIF( MSVC90 )
		SET( COMPILER_NAME vc90 )
		
	ELSEIF( MSVC10 )
		SET( COMPILER_NAME vc100 )
	
	ELSE( MSVC71 )
	MESSAGE( FATAL_ERROR "unknown VS compiler version. Update architecture.cmake" )
	
	ENDIF( MSVC71 )
ENDIF( WIN32 )
ENDIF(MINGW)

IF( UNIX )
		SET( COMPILER_NAME gcc )
	
EXEC_PROGRAM(uname OUTPUT_VARIABLE UNAME)

IF( UNAME STREQUAL "Linux" )
  EXEC_PROGRAM("uname -m" OUTPUT_VARIABLE UNAME_MACHINE)
  IF( UNAME_MACHINE STREQUAL "x86_64" )
    SET( ARCH amd64-linux )
    SET( BIN_ARCH amd64-linux )
  ELSE( UNAME_MACHINE STREQUAL "x86_64" )
    SET( ARCH linux )
    SET( BIN_ARCH linux )
  ENDIF( UNAME_MACHINE STREQUAL "x86_64" )
ENDIF( UNAME STREQUAL "Linux" )
IF( UNAME STREQUAL "FreeBSD" )
  SET( ARCH freebsd )
  SET( BIN_ARCH freebsd )
ENDIF( UNAME STREQUAL "FreeBSD" )
ENDIF( UNIX )

ENDMACRO(DETERMINE_ARCHITECTURE)